Package org.jboss.resteasy.security.smime

## Class PKCS7SignatureWriter

- java.lang.Object
- - org.jboss.resteasy.security.smime.PKCS7SignatureWriter

- All Implemented Interfaces:
    `javax.ws.rs.ext.MessageBodyWriter<SignedOutput>`, `AsyncMessageBodyWriter<SignedOutput>`

      @Provider
      @Produces("application/pkcs7-signature")
      public class PKCS7SignatureWriter
      extends Object
      implements AsyncMessageBodyWriter<SignedOutput>

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected javax.ws.rs.ext.Providers` | `providers` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PKCS7SignatureWriter()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `CompletionStage<Void>` | `asyncWriteTo​(SignedOutput out, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​Object> headers, AsyncOutputStream entityStream)` | Write a type to an HTTP message using async IO.
    `long` | `getSize​(SignedOutput smimeOutput, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `boolean` | `isWriteable​(Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` |
    `static byte[]` | `sign​(javax.ws.rs.ext.Providers providers, SignedOutput out)` |
    `void` | `writeTo​(SignedOutput out, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​Object> headers, OutputStream os)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### providers

          @Context
          protected javax.ws.rs.ext.Providers providers

  - ### Constructor Detail

    - #### PKCS7SignatureWriter

          public PKCS7SignatureWriter()

  - ### Method Detail

    - #### isWriteable

          public boolean isWriteable​(Class<?> type,
                                     Type genericType,
                                     Annotation[] annotations,
                                     javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `isWriteable` in interface `javax.ws.rs.ext.MessageBodyWriter<SignedOutput>`

    - #### getSize

          public long getSize​(SignedOutput smimeOutput,
                              Class<?> type,
                              Type genericType,
                              Annotation[] annotations,
                              javax.ws.rs.core.MediaType mediaType)

      Specified by:
        `getSize` in interface `javax.ws.rs.ext.MessageBodyWriter<SignedOutput>`

    - #### writeTo

          public void writeTo​(SignedOutput out,
                              Class<?> type,
                              Type genericType,
                              Annotation[] annotations,
                              javax.ws.rs.core.MediaType mediaType,
                              javax.ws.rs.core.MultivaluedMap<String,​Object> headers,
                              OutputStream os)
                       throws IOException,
                              javax.ws.rs.WebApplicationException

      Specified by:
        `writeTo` in interface `javax.ws.rs.ext.MessageBodyWriter<SignedOutput>`
      Throws:
        `IOException`
        `javax.ws.rs.WebApplicationException`

    - #### asyncWriteTo

          public CompletionStage<Void> asyncWriteTo​(SignedOutput out,
                                                    Class<?> type,
                                                    Type genericType,
                                                    Annotation[] annotations,
                                                    javax.ws.rs.core.MediaType mediaType,
                                                    javax.ws.rs.core.MultivaluedMap<String,​Object> headers,
                                                    AsyncOutputStream entityStream)

      Description copied from interface: `AsyncMessageBodyWriter`
      Write a type to an HTTP message using async IO. The message header map is mutable but any changes must be made before writing to the async output stream since the headers will be flushed prior to writing the message body.
      Specified by:
        `asyncWriteTo` in interface `AsyncMessageBodyWriter<SignedOutput>`
      Parameters:
        `out` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `headers` - a mutable map of the HTTP message headers.
        `entityStream` - the `AsyncOutputStream` for the HTTP entity. The implementation should not close the output stream.
      Returns:
        a `CompletionStage` indicating completion

    - #### sign

          public static byte[] sign​(javax.ws.rs.ext.Providers providers,
                                    SignedOutput out)
                             throws IOException,
                                    NoSuchAlgorithmException,
                                    NoSuchProviderException,
                                    org.bouncycastle.cms.CMSException,
                                    org.bouncycastle.operator.OperatorCreationException,
                                    CertificateEncodingException

      Throws:
        `IOException`
        `NoSuchAlgorithmException`
        `NoSuchProviderException`
        `org.bouncycastle.cms.CMSException`
        `org.bouncycastle.operator.OperatorCreationException`
        `CertificateEncodingException`